<script lang="ts">
export default {
    data(): any {
        return {
            factures: [],
            loading: true,
            showActive: false,
            facture: {}
        }
    },
    async mounted() {
        this.getFactures();
    },
    methods: {
        async getFactures() {
            const response = await fetch('http://localhost:8000/api/factures', {
                method: 'GET',
                headers: {
                    'Content-Type': 'application/json',
                }
            });
            const responseData = await response.json();
            this.factures = responseData['hydra:member'];
            this.loading = false;
        },
        async show(id: number) {
            this.facture = this.factures.find((item: any) => item.id === id);
            const response = await fetch('http://localhost:8000/api/detail_deviss', {
                method: 'GET',
                headers: {
                    'Content-Type': 'application/json',
                }
            });
            const responseData = await response.json();
            let detailDevis = responseData['hydra:member'];
            for (const detail of detailDevis) {
                if (detail.devis !== this.facture.devis) {
                    continue;
                }
                const responseDevis = await fetch('http://localhost:8000' + detail.devis, {
                    method: 'GET',
                    headers: {
                        'Content-Type': 'application/json',
                    }
                });
                const responseDataDevis = await responseDevis.json();
                const responseClient = await fetch('http://localhost:8000' + responseDataDevis.client, {
                    method: 'GET',
                    headers: {
                        'Content-Type': 'application/json',
                    }
                });
                const responseDataClient = await responseClient.json();
                responseDataDevis.client = responseDataClient;
                if (responseDataDevis.statut === 'En attente') {
                    responseDataDevis.statuscolor = 'primary';
                } else if (responseDataDevis.statut === 'Accepté') {
                    responseDataDevis.statuscolor = 'success';
                } else {
                    responseDataDevis.statuscolor = 'error';
                }
                let montant = 0;
                for (let i=0; i<detail.product.length; i++) {
                    const responseProduct = await fetch('http://localhost:8000' + detail.product[i], {
                        method: 'GET',
                        headers: {
                            'Content-Type': 'application/json',
                        }
                    });
                    const responseDataProduct = await responseProduct.json();
                    detail.product[i] = responseDataProduct;
                    montant += responseDataProduct.prix;
                }
                responseDataDevis.budget = montant;
                responseDataDevis.detail = detail;
                this.facture.devis_detail = responseDataDevis;
                break;
            }
            this.showActive = true;
            console.log(this.facture);
        }
    }
}
</script>

<template>
    <v-row align="center">
        <v-col cols="12" lg="3">
            <h1>Liste des factures</h1>
        </v-col>


        <v-dialog v-model="showActive" max-width="800px">
            <v-card>
                <v-card-title>
                    <span class="headline">Facture {{ facture.id }}</span>
                    <v-chip  :class="'text-body-1 bg-' + (facture.paiement_ok == 1 ? 'success' : 'error') " class="ml-10" color="white"  size="small" >{{
                        (facture.paiement_ok == 1 ? 'Paiement OK' : 'Paiement non OK')
                    }}</v-chip>
                </v-card-title>
                <v-card-text>
                    <v-row>
                        <v-col cols="12" lg="6">
                            <v-card>
                                <v-card-title>
                                    <span class="headline">Informations</span>
                                </v-card-title>
                                <v-card-text>
                                    <p><b>Devis:</b> {{ facture.devis_detail.id }}</p>
                                    <p><b>Date:</b> {{ facture.devis_detail.date_creation }}</p>
                                    <p><b>Montant:</b> {{ facture.devis_detail.budget }} €</p>
                                </v-card-text>
                            </v-card>
                        </v-col>
                        <v-col cols="12" lg="6">
                            <v-card>
                                <v-card-title>
                                    <span class="headline">Client</span>
                                </v-card-title>
                                <v-card-text>
                                    <p><b>Nom:</b> {{ facture.devis_detail.client.nom }}</p>
                                    <p><b>Adresse:</b> {{ facture.devis_detail.client.adresse }}</p>
                                    <p><b>Email:</b> {{ facture.devis_detail.client.email }}</p>
                                </v-card-text>
                            </v-card>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col cols="12">
                            <v-card>
                                <v-card-title>
                                    <span class="headline">Produits</span>
                                </v-card-title>
                                <v-card-text>
                                    <v-table>
                                        <thead>
                                            <tr>
                                                <th class="text-subtitle-1 font-weight-bold">Nom</th>
                                                <th class="text-subtitle-1 font-weight-bold">Prix</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr v-for="product in facture.devis_detail.detail.product" :key="product.id">
                                                <td>
                                                    <p class="text-15 font-weight-medium">{{ product.nom }}</p>
                                                </td>
                                                <td>
                                                    <p class="text-15 font-weight-medium">{{ product.prix }} €</p>
                                                </td>
                                            </tr>
                                        </tbody>
                                    </v-table>
                                </v-card-text>
                            </v-card>
                        </v-col>
                    </v-row>
                </v-card-text>
                <v-card-actions>
                    <v-btn color="primary" text @click="showActive = false">Fermer</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-col cols="12">
            <v-row>
                <v-col cols="12" lg="12">
                    
                    <v-card elevation="10" class="">
                        <v-card-item class="py-2 px-4">
                            <v-table class="month-table">
                                <thead>
                                    <tr>
                                        <th class="text-subtitle-1 font-weight-bold">Id</th>
                                        <th class="text-subtitle-1 font-weight-bold">Id Devis</th>
                                        <th class="text-subtitle-1 font-weight-bold">Date création</th>
                                        <th class="text-subtitle-1 font-weight-bold">Paiement</th>
                                        <th class="text-subtitle-1 font-weight-bold text-right"></th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr v-for="item in factures" :key="item.id" class="month-item">
                                        <td>
                                            <p class="text-15 font-weight-medium">{{ item.id }}</p>
                                        </td>
                                        <td>
                                            <p class="text-15 font-weight-medium">{{ (item.devis) }}</p>
                                        </td>
                                        <td>
                                            <div class="">
                                                <h6 class="text-subtitle-1 font-weight-bold">{{ item.date_creation }}</h6>
                                            </div>
                                        </td>
                                        <td>
                                            <v-chip  :class="'text-body-1 bg-' + (item.paiement_ok == 1 ? 'success' : 'error') " color="white"  size="small" >{{
                                                (item.paiement_ok == 1 ? 'OK' : 'Non OK')
                                            }}</v-chip>
                                        </td>
                                        <td class="text-right">
                                            <v-btn @click="show(item.id)" color="primary" variant="outlined">Visionner</v-btn>
                                        </td>
                                    </tr>
                                </tbody>
                            </v-table>
                            <div class="container-loader">
                                <div v-if="loading" class="loader"></div>
                            </div>
                        </v-card-item>
                    </v-card>
                </v-col>
            </v-row>
        </v-col>
    </v-row>
</template>

<style scoped>
    .container-loader{
        display: flex;
        justify-content: center;
        align-items: center;
        width: 100%;
    }
    .loader {
        position: relative;
        width: 50px;
        height: 50px;
        border: 3px solid rgb(255,111,0);
        border-radius: 50%;
        border-top-color: transparent;
        animation: spin 1s linear infinite;
        margin: auto auto;
    }
    @keyframes spin {
        0% { transform: rotate(0deg); }
        100% { transform: rotate(360deg); }
    }
</style>